// SingletonPtr is a wraper class that encapsulate all singleton access.
// T must be Singleton class.
template <class T>
class SingletonPtr {
public:
	operator bool() const { return T::instance() != NULL; };
	bool  operator !() const { return T::instance() == NULL; };

	operator T*() const { return T::instance(); }
  operator const T*() const { return T::instance(); }
	T& operator*() const { return *T::instance(); }
  T* operator->(void) const { return T::instance(); }
};
